Subject: Re: [PATCH] usb: mtk-xhci: Set the XHCI_NO_64BIT_SUPPORT quirk

From: Chunfeng Yun <[email-masked]>
Date: Thu, 10 Oct 2019 18:59:07 +0800

On Thu, 2019-10-10 at 18:00 +0900, Tomasz Figa wrote:
> Hi Chunfeng,
> 
> On Thu, Oct 10, 2019 at 5:45 PM Chunfeng Yun <[email-masked]> wrote:
> >
> > Hi, Tomasz,
> >
> > On Thu, 2019-10-10 at 16:50 +0900, Tomasz Figa wrote:
> > > MediaTek XHCI host controller does not support 64-bit addressing despite
> > > the AC64 bit of HCCPARAMS1 register being set. The platform-specific
> > > glue sets the DMA mask to 32 bits on its own, but it has no effect,
> > > because xhci_gen_setup() overrides it according to hardware
> > > capabilities.
Yes, this is what I want to do, maybe need remove DMA mask setting in
platform-specific.

> > >
> > > Use the XHCI_NO_64BIT_SUPPORT quirk to tell the XHCI core to force
> > > 32-bit DMA mask instead.
> > >
> > > Signed-off-by: Tomasz Figa <[email-masked]>
> > > ---
> > >  drivers/usb/host/xhci-mtk.c | 10 +++++-----
> > >  1 file changed, 5 insertions(+), 5 deletions(-)
> > >
> > > diff --git a/drivers/usb/host/xhci-mtk.c b/drivers/usb/host/xhci-mtk.c
> > > index b18a6baef204a..4d101d52cc11b 100644
> > > --- a/drivers/usb/host/xhci-mtk.c
> > > +++ b/drivers/usb/host/xhci-mtk.c
> > > @@ -395,6 +395,11 @@ static void xhci_mtk_quirks(struct device *dev, struct xhci_hcd *xhci)
> > >       xhci->quirks |= XHCI_SPURIOUS_SUCCESS;
> > >       if (mtk->lpm_support)
> > >               xhci->quirks |= XHCI_LPM_SUPPORT;
> > > +     /*
> > > +      * MTK host controller does not support 64-bit addressing, despite
> > > +      * having the AC64 bit of the HCCPARAMS1 register set.
> > > +      */
> > > +     xhci->quirks |= XHCI_NO_64BIT_SUPPORT;
> > Somes SoCs support 64bits in fact, so can't support this quirk, do you
> > encounter any issues without this quirk?
> >
> 
> Thanks for taking a look at this patch.
> 
> Yes, on MT8183 the DMA mask ended up being set to 64 bits, but
> according to the information I received from MediaTek, the controller
> on that SoC only supports 32 bits.
As I know, mt8183 doesn't support memory greater than 4G mode.

> 
> If some SoCs support only 32 bits and some support 64 bits, we may
> either need to use different DT compatible string for them or add a DT
> property and set the quirk based on that. Right now in upstream we
> have:
> 
> 1) "mediatek,mt8173-xhci", used by:
> MT8173
> 
> 2)"mediatek,mtk-xhci", used by:
> MT2712
> MT7622
> MT8183 (not yet upstream, but I suppose it's on the mailing lists)
> 
> Would you be able to check which of the SoCs above report 64 bits but
> support only 32? (and so would need this quirk)
I'm afraid I can't, almost all MTK SoCs supporting xHCI are using this
driver, AC64 should be set rightly according to addressing capability.

> 
> Best regards,
> Tomasz
> 
> > >  }
> >
> > >
> > >  /* called during probe() after chip reset completes */
> > > @@ -488,11 +493,6 @@ static int xhci_mtk_probe(struct platform_device *pdev)
> > >               goto disable_clk;
> > >       }
> > >
> > > -     /* Initialize dma_mask and coherent_dma_mask to 32-bits */
> > > -     ret = dma_set_mask_and_coherent(dev, DMA_BIT_MASK(32));
> > > -     if (ret)
> > > -             goto disable_clk;
> > > -
> > >       hcd = usb_create_hcd(driver, dev, dev_name(dev));
> > >       if (!hcd) {
> > >               ret = -ENOMEM;
> >
> >

_______________________________________________
linux-arm-kernel mailing list
[email-masked]
http://lists.infradead.org/mailman/listinfo/linux-arm-kernel